unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, ComCtrls, ImgList, Menus, ToolWin, StdCtrls, CheckLst,
  ExtCtrls, Grids, Buttons, StrUtils, inifiles;

type
  TformMenuPrincipal = class(TForm)
    MainMenu1: TMainMenu;
    ImageList1: TImageList;
    be: TStatusBar;
    ActionList1: TActionList;
    dlAbrir: TOpenDialog;
    lsFicheros: TCheckListBox;
    actSeleccionarFicheros: TAction;
    Archivo1: TMenuItem;
    Seleccionarficheros1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    actSalir: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    N1: TMenuItem;
    Salir1: TMenuItem;
    Ayuda1: TMenuItem;
    Panel1: TPanel;
    actFiltros: TAction;
    ToolButton4: TToolButton;
    Filtros1: TMenuItem;
    Splitter1: TSplitter;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    actSelecionarTodos: TAction;
    actDesmarcarTodos: TAction;
    Panel2: TPanel;
    tabla: TStringGrid;
    actPasarSeleccionados: TAction;
    Seleccin1: TMenuItem;
    Seleccionarficheros2: TMenuItem;
    Desmarcartodos1: TMenuItem;
    Seleccionarficheros3: TMenuItem;
    N2: TMenuItem;
    Renombrar1: TMenuItem;
    Pasarseleccionados1: TMenuItem;
    Filtrosaaplicar1: TMenuItem;
    lInfoSeleccionados: TLabel;
    actRenombrar: TAction;
    actInvertirSeleccion: TAction;
    SpeedButton6: TSpeedButton;
    Invertirseleccin1: TMenuItem;
    txtCombinacion: TComboBox;
    actSimular: TAction;
    Simular1: TMenuItem;
    Renombrar2: TMenuItem;
    Seleccionartodos1: TMenuItem;
    Renombrar3: TMenuItem;
    actAcercaDe: TAction;
    Acercade1: TMenuItem;
    ToolButton5: TToolButton;
    actLimpiarSeleccion: TAction;
    Limpiarseleccin1: TMenuItem;
    N3: TMenuItem;
    bPasarSeleccionados: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    actOcultarSeleccion: TAction;
    N4: TMenuItem;
    Limpiarseleccin2: TMenuItem;
    procedure actSalirExecute(Sender: TObject);
    procedure actSeleccionarFicherosExecute(Sender: TObject);
    procedure actFiltrosExecute(Sender: TObject);
    procedure actSelecionarTodosExecute(Sender: TObject);
    procedure actDesmarcarTodosExecute(Sender: TObject);
    procedure actPasarSeleccionadosExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lsFicherosClick(Sender: TObject);
    procedure actInvertirSeleccionExecute(Sender: TObject);
    procedure actRenombrarExecute(Sender: TObject);
    procedure actSimularExecute(Sender: TObject);
    procedure iniciarRenombrado (simular : boolean);
    procedure actLimpiarSeleccionExecute(Sender: TObject);
    procedure actOcultarSeleccionExecute(Sender: TObject);
    procedure actAcercaDeExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  posicionCombinacionDefecto : integer;
  function existeFicheroEnLista (lista : TStrings; fichero : string) : boolean;
  function extraerSoloNombreFichero (fichero : string) : string;
  function cargarListaFicheros (carpeta : string; filtro : string) : TStringList;
  function cargarCombinacionFiltros (nombreDefecto : string) : TStringList;
  function renombrarFicheros (listaFicheros : TStringList; listaFiltros : TStringList; simular : boolean) : TStringList;
  function todoEnMayusculas (fichero : string) : string;
  function todoEnMinusculas (fichero : string) : string;
  function suprimirNumeros (fichero : string) : string;
  function suprimirTextoEspecificado (fichero : string; texto : string) : string;
  function suprimirPrimerosCaracteres (fichero : string; numCaracteres : integer) : string;
  function suprimirUltimosCaracteres (fichero : string; numCaracteres : integer) : string;
  function primeraLetraFicheroMayuscula (fichero : string) : string;
  function insertarNumeroAutomaticoFinal (numeroActualInsertar : integer; numFicheros : integer; fichero : string) : string;
  function insertarNumeroAutomaticoInicio (numeroActualInsertar : integer; numFicheros : integer; fichero : string) : string;
  function cambiarExtensionFichero (extension : string) : string;
  function insertarTextoAlFinal (fichero, texto : string) : string;
  function insertarTextoAlPrincipio (fichero, texto : string) : string;
  function primeraLetraPalabrasMayuscula (fichero : string) : string;
  procedure esCadINI (clave, cadena, valor : string);
  function leCadINI (clave, cadena : string; defecto : string) : string;
  procedure esEntINI (clave, cadena : string; valor : integer);
  function leEntINI (clave, cadena : string; defecto : integer) : integer;  
implementation

uses UnidadFiltros, AcercaDe;

{$R *.dfm}

//Escribe un entero en un INI
procedure esEntINI (clave, cadena : string; valor : integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeInteger (clave, cadena, valor);
  finally
    free;
  end;
end;

//Lee un entero de un INI
function leEntINI (clave, cadena : string; defecto : integer) : integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

//Lee una cadena de texto de un INI
function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;


//escribe una cadena de texto en un INI
procedure esCadINI (clave, cadena, valor : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeString (clave, cadena, valor);
  finally
    free;
  end;
end;


function todoEnMayusculas (fichero : string) : string;
begin
  result := AnsiUpperCase (fichero);
end;

function todoEnMinusculas (fichero : string) : string;
begin
  result := AnsiLowerCase (fichero);
end;

function suprimirNumeros (fichero : string) : string;
var
  ficheroTemporal : string;
  k : integer;
begin
  ficheroTemporal := '';
  for k := 1 to Length (fichero) do
  begin
    if (fichero[k] in ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0']) then
    else
      ficheroTemporal := ficheroTemporal + fichero[k];
  end;
  Result := ficheroTemporal;
end;

function suprimirTextoEspecificado (fichero : string; texto : string) : string;
begin
  repeat
    if Pos (texto, fichero) > 0 then
      Delete (fichero, pos(texto, fichero), length(texto));
  until pos (texto, fichero) = 0;
  Result := fichero;
end;

function suprimirPrimerosCaracteres (fichero : string; numCaracteres : integer) : string;
begin
  try
    if Length (fichero) >= numCaracteres then
      Result := copy (fichero, numCaracteres, length (fichero))
    else
      Result := fichero;
  except
    Result := fichero;
  end;
end;

function suprimirUltimosCaracteres (fichero : string; numCaracteres : integer) : string;
begin
  try
    if Length (fichero) >= numCaracteres then
      Result := copy (fichero, 1, length (fichero) - numCaracteres)
    else
      Result := fichero;
  except
    Result := fichero;
  end;
end;

function primeraLetraFicheroMayuscula (fichero : string) : string;
var
  ficheroTemporal : string;
begin
  if Length(fichero) > 0 then
  begin
    ficheroTemporal := fichero;
    ficheroTemporal := AnsiUpperCase(ficheroTemporal[1]);
    if Length (fichero) > 1 then
      ficheroTemporal := ficheroTemporal + copy (fichero, 2, length(fichero));
    Result := ficheroTemporal;
  end
  else
    Result := '';
end;

function insertarNumeroAutomaticoFinal (numeroActualInsertar : integer; numFicheros : integer; fichero : string) : string;
var
  numeroCaracteres, k : Integer;
  numeroInsertar : string;
begin
  numeroCaracteres := length (inttostr (numFicheros));
  numeroInsertar := inttostr(numeroActualInsertar + 1);
  for k := 0 to  numeroCaracteres - length(inttostr(numeroActualInsertar)) - 1 do
    numeroInsertar := '0' + numeroInsertar;
  Result := fichero + numeroInsertar;
end;

function insertarNumeroAutomaticoInicio (numeroActualInsertar : integer; numFicheros : integer; fichero : string) : string;
var
  numeroCaracteres, k : Integer;
  numeroInsertar : string;
begin
  numeroCaracteres := length (inttostr (numFicheros));
  numeroInsertar := inttostr(numeroActualInsertar + 1);
  for k := 0 to  numeroCaracteres - length(inttostr(numeroActualInsertar)) - 1 do
    numeroInsertar := '0' + numeroInsertar;
  Result := numeroInsertar + fichero;
end;

function cambiarExtensionFichero (extension : string) : string;
begin
  Result := extension;
end;

function insertarTextoAlFinal (fichero, texto : string) : string;
begin
  Result := fichero + texto;
end;

function insertarTextoAlPrincipio (fichero, texto : string) : string;
begin
  Result := texto + fichero;
end;

function primeraLetraPalabrasMayuscula (fichero : string) : string;
var
  espacioAnterior : boolean;
  ficheroTemporal : string;
  k : integer;
begin
  ficheroTemporal := fichero;
  espacioAnterior := false;
  for k := 1 to Length(ficheroTemporal) do
  begin
    if k = 1 then
      ficheroTemporal := ansiuppercase(ficherotemporal[k]) + copy (ficheroTemporal, k + 1, length(ficheroTemporal));
    if espacioAnterior then
    begin
      ficheroTemporal := copy (ficheroTemporal, 1, k - 1) +
          ansiuppercase(ficherotemporal[k]) + copy (ficheroTemporal, k + 1, length(ficheroTemporal));
    end;
    espacioAnterior := ficheroTemporal[k] = ' ';
  end;
  Result := ficheroTemporal;
end;

function extraerSoloNombreFichero (fichero : string) : string;
var
  ficheroFinal : string;
begin
  ficheroFinal := ExtractFileName(fichero);
  ficheroFinal := copy (ficheroFinal, 1, pos (ExtractFileExt (ficheroFinal), ficheroFinal) - 1);
  Result := ficheroFinal;
end;

function reemplazarTexto (fichero : string; texto : string) : string;
var
  textoBuscar : string;
  textoNuevo : string;
begin
  //buscamos las dos barras para separar el texto en las dos variables
  textoBuscar := copy (texto, 1, pos('//', texto) - 1);
  textoNuevo := copy (texto, pos('//', texto) + 2, length(texto));
  repeat
    if Pos (textoBuscar, fichero) > 0 then
      fichero := AnsiReplaceStr(fichero, textoBuscar, textoNuevo);
  until pos (texto, fichero) = 0;
  Result := fichero;
end;



function renombrarFicheros (listaFicheros : TStringList; listaFiltros : TStringList; simular : boolean) : TStringList;
var
  i, j : integer;
  listaResultado : TStringList;
  ficheroActual : string;
  ficheroActualSinRuta : string;
  ficheroActualSinExtension : string;
  ruta : string;
  extensionActual : string;
  extensionResultante : string;
  ficheroResultante : string;
  regla : string;
  valorRegla : string;
begin
  listaResultado := TStringList.Create;
  for i := 0 to listaFicheros.Count - 1 do
  begin
    ficheroActual := listaFicheros.Strings[i];
    ruta := ExtractFilePath(ficheroActual);
    ficheroActualSinRuta := ExtractFileName(ficheroActual);
    ficheroActualSinExtension := extraerSoloNombreFichero(ficheroActual);
    extensionActual := ExtractFileExt(ficheroActual);
    //le quitamos el punto a la extensin
    if Length(extensionActual) > 0 then
      if extensionActual[1] = '.' then
        extensionActual := copy (extensionActual, 2, length(extensionActual));
    //empezamos a aplicar las reglas seleccionadas
    ficheroResultante := ficheroActualSinExtension;
    extensionResultante := extensionActual;
    for j := 0 to listaFiltros.Count - 1 do
    begin
      regla := listaFiltros.Strings[j];
      //puesto que el valor se separa con "=" buscamos el primer "=" que aparezca
      //pues en la clave (primera columna) no hay "="
      valorRegla := copy (regla, pos ('=', regla) + 1, length (regla));
      regla := copy (regla, 1, pos ('=', regla) - 1);

      if regla = 'Aadir texto al final' then
        ficheroResultante := insertarTextoAlFinal (ficheroResultante, valorRegla);

      if regla = 'Aadir texto al principio' then
        ficheroResultante := insertarTextoAlPrincipio(ficheroResultante, valorRegla);

      if regla = 'Cambiar la extensin' then
        extensionResultante := cambiarExtensionFichero (valorRegla);

      if regla = 'Colocar nmero automtico al final' then
        ficheroResultante := insertarNumeroAutomaticoFinal (i, listaFicheros.Count, ficheroResultante);

      if regla = 'Colocar nmero automtico al principio' then
        ficheroResultante := insertarNumeroAutomaticoInicio (i, listaFicheros.Count, ficheroResultante);

      if regla = 'Primera letra de cada palabra en maysculas' then
        ficheroResultante := primeraLetraPalabrasMayuscula (ficheroResultante);

      if regla = 'Primera letra en maysculas' then
        ficheroResultante := primeraLetraFicheroMayuscula (ficheroResultante);

      if regla = 'Suprimir los primeros caracteres' then
      begin
        try
          ficheroResultante := suprimirPrimerosCaracteres (ficheroResultante, strtoint(valorRegla));
        except
        end;
      end;

      if regla = 'Suprimir los ltimos caracteres' then
      begin
        try
          ficheroResultante := suprimirUltimosCaracteres (ficheroResultante, strtoint(valorRegla));
        except
        end;
      end;

      if regla = 'Suprimir texto especificado' then
        ficheroResultante := suprimirTextoEspecificado (ficheroResultante, valorRegla);

      if regla = 'Suprimir todos los nmeros' then
        ficheroResultante := suprimirNumeros (ficheroResultante);

      if regla = 'Todo en maysculas' then
        ficheroResultante := todoEnMayusculas (ficheroResultante);

      if regla = 'Todo en minsculas' then
        ficheroResultante := todoEnMinusculas (ficheroResultante);

      if regla = 'Reemplazar texto' then
        ficheroResultante := reemplazarTexto (ficheroResultante, valorRegla);
    end;
    //guardamos el resultado de la aplicacin de las reglas
    if simular then
      listaResultado.Add (ficheroResultante + '.' + extensionResultante)
    else
    begin
      if RenameFile(ficheroActual, ruta + ficheroResultante + '.' + extensionResultante) then
        listaResultado.Add ('Correcto -> ' + ficheroResultante + '.' + extensionResultante)
      else
        listaResultado.Add ('Error -> No ha podido ser renombrado');
    end;
  end;
  Result := listaResultado;
end;

function cargarCombinacionFiltros (nombreDefecto : string) : TStringList;
var
  lista : tstringList;
  listaSinExtension : TStringList;
  i : integer;
begin
  posicionCombinacionDefecto := 0;
  lista := cargarListaFicheros(ExtractFilePath(Application.ExeName), '*.flt');
  lista.Sorted := true;
  lista.Sort;
  listaSinExtension := TStringList.Create;
  for i := 0 to lista.count - 1 do
  begin
    listaSinExtension.Add(extraerSoloNombreFichero(lista.Strings[i]));
    if extraerSoloNombreFichero(lista.Strings[i]) = nombreDefecto then
      posicionCombinacionDefecto := i;
  end;
  result := listaSinExtension;
end;


function cargarListaFicheros (carpeta : string; filtro : string) : TStringList;
var
  sr : TSearchRec;
  lista : TStringList;
begin
  lista := TStringList.Create;
  if FindFirst(carpeta + filtro, faAnyFile, sr) = 0 then
  begin
    repeat
      if (sr.Name <> '') and (sr.Name <> '.') and (sr.Name <> '..') then
        lista.Add (sr.name);
    until FindNext(sr) <> 0;
  end;
  FindClose(sr);
  Result := lista;
end;

function existeFicheroEnLista (lista : TStrings; fichero : string) : boolean;
var
  i : integer;
begin
  result := false;
  for i := 0 to lista.Count - 1 do
  begin
    if lista.Strings[i] = fichero then
    begin
      result := true;
      Break;
    end;
  end;
end;


function numeroSeleccionados (lista : TCheckListBox) : integer;
var
  i : integer;
  numero : integer;
begin
  numero := 0;
  for i := 0 to lista.Count - 1 do
    if lista.Checked[i] then
      numero := numero + 1;
  result := numero;
end;

procedure TformMenuPrincipal.iniciarRenombrado (simular : boolean);
var
  listaFicheros : TStringList;
  listaFiltros : TStringList;
  i : integer;
  fichero : string;
  fila : integer;
  lista : TStringList;
begin
  if (tabla.RowCount > 1) and (tabla.Cells[1,1] <> '') then
  begin
    if txtCombinacion.Text <> '' then
    begin
      fichero := ExtractFilePath(Application.ExeName) + txtCombinacion.Text + '.flt';
      if FileExists(fichero) then
      begin
        listaFicheros := TStringList.Create;
        listaFiltros := TStringList.Create;
        for i := 1 to tabla.RowCount do
          listaFicheros.Add (tabla.Cells [1, i]);
        listaFiltros.LoadFromFile(fichero);
        lista := renombrarFicheros (listaFicheros, listaFiltros, simular);
        fila := 1;
        for i := 0 to lista.Count - 1 do
        begin
          tabla.RowCount := fila;
          if (lista.Strings[i] <> '') and (lista.Strings[i] <> '.') then
            tabla.Cells [2, fila] := lista.Strings[i];
          fila := fila + 1;
          //be.panels[1].text := 'Ficheros a renombrar: ' + inttostr(tabla.RowCount - 1);
        end;
      end
      else
        MessageDlg('La combinacin de filtros: ' + fichero + ' no existe.' +
            chr(13) + chr(13) + 'Recuerde que debe copiar los filtros en la ' +
            'carpeta de la aplicacin.', mtWarning, [mbok], 0);
    end
    else
    begin
      MessageDlg('Debe seleccionar una combinacin de filtros existente.', mtWarning, [mbok], 0);
      txtCombinacion.SetFocus;
    end;
  end
  else
  begin
    MessageDlg('Debe seleccionar los ficheros a renombrar.', mtWarning, [mbok], 0);
    if lsFicheros.Count > 0 then
      bPasarSeleccionados.SetFocus
    else
      actSeleccionarFicherosExecute (nil);
  end;
end;

procedure TformMenuPrincipal.actSalirExecute(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.actSeleccionarFicherosExecute(
  Sender: TObject);
var
  i : integer;
  rutaDefecto : string;
begin
  rutaDefecto := leCadINI('Datos inicio', 'Ruta', '');
  if DirectoryExists (rutaDefecto) then
    dlAbrir.InitialDir := rutaDefecto;
  dlAbrir.Title := 'Seleccione los ficheros a renombrar...';
  dlAbrir.Filter := 'Msica (*.mp3)|*.mp3|Videos (*.avi)|*.avi|Aplicaciones (*.exe)|*.exe|Imgenes (*.jpg)|*.jpg|Todos los ficheros (*.*)|*.*';
  dlAbrir.DefaultExt := '';
  dlAbrir.Options := [ofHideReadOnly,ofAllowMultiSelect,ofEnableSizing];
  if dlAbrir.Execute then
  begin
    for i := 0 to dlAbrir.Files.Count - 1 do
      if not existeFicheroEnLista(lsFicheros.Items, dlAbrir.Files[i]) then
        lsFicheros.Items.Add (dlAbrir.Files[i]);
    actSelecionarTodosExecute(nil);
    lInfoSeleccionados.Caption :=  'Seleccionados: ' + inttostr(numeroSeleccionados(lsFicheros));
  end;
end;

procedure TformMenuPrincipal.actFiltrosExecute(Sender: TObject);
var
  i : integer;
begin
  formFiltros.txtCombinacion.Items := cargarCombinacionFiltros (txtCombinacion.Items[txtCombinacion.ItemIndex]);
  formFiltros.txtCombinacion.ItemIndex := posicionCombinacionDefecto;
  formFiltros.ShowModal;
  txtCombinacion.Items := cargarCombinacionFiltros (formMenuPrincipal.txtCombinacion.Text);
  for i := 0 to txtCombinacion.Items.Count do
    if txtCombinacion.Items[i] = formFiltros.txtCombinacion.Text then
    begin
      txtCombinacion.ItemIndex := i;
      break;
    end;
end;

procedure TformMenuPrincipal.actSelecionarTodosExecute(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to lsFicheros.Count - 1 do
  begin
    lsFicheros.Checked[i] := true;
  end;
  lInfoSeleccionados.Caption :=  'Seleccionados: ' + inttostr(numeroSeleccionados(lsFicheros));
end;

procedure TformMenuPrincipal.actDesmarcarTodosExecute(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to lsFicheros.Count - 1 do
  begin
    lsFicheros.Checked[i] := false;
  end;
  lInfoSeleccionados.Caption :=  'Seleccionados: ' + inttostr(numeroSeleccionados(lsFicheros));  
end;

procedure TformMenuPrincipal.actPasarSeleccionadosExecute(Sender: TObject);
var
  i : integer;
  fila : integer;
begin
  fila := 1;
  for i := 0 to lsFicheros.Count - 1 do
  begin
    if lsFicheros.Checked[i] then
    begin
      tabla.RowCount := fila + 1;
      tabla.Cells [1, fila] := lsFicheros.Items[i];
      fila := fila + 1;
      be.panels[1].text := 'Ficheros a renombrar: ' + inttostr(tabla.RowCount - 1);
    end;
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  tabla.Cells [1,0] := 'Antes';
  tabla.Cells [2,0] := 'Despus';
  //cargamos las combinaciones de filtros disponibles
  txtCombinacion.Items := cargarCombinacionFiltros ('');
  if txtCombinacion.Items.Count >= txtCombinacion.ItemIndex then
    txtCombinacion.ItemIndex := leEntINI ('Datos inicio', 'Filtro', -1);
end;

procedure TformMenuPrincipal.lsFicherosClick(Sender: TObject);
begin
  lInfoSeleccionados.Caption :=  'Seleccionados: ' + inttostr(numeroSeleccionados(lsFicheros));
end;

procedure TformMenuPrincipal.actInvertirSeleccionExecute(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to lsFicheros.Count - 1 do
  begin
    lsFicheros.Checked[i] := not lsFicheros.Checked[i];
  end;
  lInfoSeleccionados.Caption :=  'Seleccionados: ' + inttostr(numeroSeleccionados(lsFicheros));
end;

procedure TformMenuPrincipal.actRenombrarExecute(Sender: TObject);
begin
  If MessageDlg('Se va a proceder a renombrar los ficheros seleccionados. ' +
      'Recuerde que es conveniente hacer una simulacin previa.' +
      'Desea continuar con el proceso?', mtConfirmation, [mbyes,mbno],0) = mryes then
  begin
    Screen.Cursor := crHourGlass;
    be.Panels[1].Text := 'Renombrando ficheros';
    be.Refresh;
    Sleep(500);
    iniciarRenombrado(false);
    be.Panels[1].Text := 'Fin del proceso';
    be.Refresh;
    Screen.Cursor := crDefault;
  end;
end;

procedure TformMenuPrincipal.actSimularExecute(Sender: TObject);
begin
  iniciarRenombrado (true);
end;

procedure TformMenuPrincipal.actLimpiarSeleccionExecute(Sender: TObject);
begin
  tabla.RowCount := 2;
  tabla.Cells [1, 1] := '';
  tabla.Cells [2, 1] := '';
end;

procedure TformMenuPrincipal.actOcultarSeleccionExecute(Sender: TObject);
begin
  lsFicheros.Clear;
end;

procedure TformMenuPrincipal.actAcercaDeExecute(Sender: TObject);
begin
  formacercade.show;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  esEntINI ('Datos inicio', 'Filtro', txtCombinacion.ItemIndex);
  if DirectoryExists (ExtractFilePath (tabla.Cells [1, 2])) then
    esCadINI('Datos inicio', 'Ruta', ExtractFilePath (tabla.Cells [1, 2]));
end;

end.
