unit UnidadValor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TformValor = class(TForm)
    txtValor: TComboBox;
    lTexto: TLabel;
    bSeleccionar: TButton;
    bCancelar: TButton;
    lTexto2: TLabel;
    txtValor2: TComboBox;
    procedure bSeleccionarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formValor: TformValor;

implementation

uses UnidadSeleccionFiltros, UnidadMenuPrincipal;


{$R *.dfm}

procedure TformValor.bSeleccionarClick(Sender: TObject);
begin
  textoSeleccionado := txtValor.Text;
  //si es "Reemplazar texto" aadimos el texto por el que se reemplazar
  if Tag = 70 then
    textoSeleccionado := textoSeleccionado + '//' + txtValor2.Text;

  if not existeFicheroEnLista(txtValor.Items, textoSeleccionado) then
    txtValor.Items.Add(textoSeleccionado);
  //suprimir texto
  if Tag = 10 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'SuprimirTexto.txt');
  //suprimir los primeros caracteres
  if Tag = 20 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'SuprimirCaracteresPrimeros.txt');
  //suprimir los ltimos caracteres
  if Tag = 30 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'SuprimirCaracteresUltimos.txt');

  //Aadir texto al principio
  if Tag = 40 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'TextoInicial.txt');

  //Aadir texto al final
  if Tag = 50 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'TextoFinal.txt');

  //Cambiar la extensin
  if Tag = 60 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'CambiarExtension.txt');

  //Reemplazar texto
  if Tag = 70 then
  begin
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'Reemplazar.txt');
    txtValor2.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'ReemplazarPor.txt');
  end;

  //Guardar combinacin como
  if Tag = 200 then
    txtValor.Items.SaveToFile(ExtractFilePath(Application.ExeName) + 'Combinaciones.txt');

  Close;
end;

procedure TformValor.FormShow(Sender: TObject);
begin
  txtValor.Clear;
  txtValor.SetFocus;

  //suprimir texto
  if Tag = 10 then
  begin
    Caption := 'Texto a suprimir';
    lTexto.Caption := 'Texto';
    if FileExists(ExtractFilePath(Application.ExeName) + 'SuprimirTexto.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'SuprimirTexto.txt');
  end;

  //suprimir los primeros caracteres
  if Tag = 20 then
  begin
    Caption := 'Nmero de caracteres a suprimir (primeros)';
    lTexto.Caption := 'Nmero';
    if FileExists(ExtractFilePath(Application.ExeName) + 'SuprimirCaracteresPrimeros.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'SuprimirCaracteresPrimeros.txt');
  end;

  //suprimir los ltimos caracteres
  if Tag = 30 then
  begin
    Caption := 'Nmero de caracteres a suprimir (ltimos)';
    lTexto.Caption := 'Nmero';
    if FileExists(ExtractFilePath(Application.ExeName) + 'SuprimirCaracteresUltimos.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'SuprimirCaracteresUltimos.txt');
  end;

  //Aadir texto al principio
  if Tag = 40 then
  begin
    Caption := 'Aadir texto al principio';
    lTexto.Caption := 'Texto';
    if FileExists(ExtractFilePath(Application.ExeName) + 'TextoInicial.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'TextoInicial.txt');
  end;

  //Aadir texto al final
  if Tag = 50 then
  begin
    Caption := 'Aadir texto al final';
    lTexto.Caption := 'Texto';
    if FileExists(ExtractFilePath(Application.ExeName) + 'TextoFinal.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'TextoFinal.txt');
  end;

  //cambiar la extensin
  if Tag = 60 then
  begin
    Caption := 'Cambiar la extensin';
    lTexto.Caption := 'Extensin';
    if FileExists(ExtractFilePath(Application.ExeName) + 'CambiarExtension.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'CambiarExtension.txt');
  end;

  //Reemplazar texto
  if Tag = 70 then
  begin
    Caption := 'Reemplazar texto';
    lTexto.Caption := 'Texto a buscar';
    lTexto2.Caption := 'Reemplazar por';
    Height := 98;
    lTexto2.Visible := true;
    txtValor2.Visible := true;
    if FileExists(ExtractFilePath(Application.ExeName) + 'Reemplazar.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Reemplazar.txt');
    if FileExists(ExtractFilePath(Application.ExeName) + 'ReemplazarPor.txt') then
      txtValor2.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'ReemplazarPor.txt');
  end;

  //nombre de la combinacin a guardar
  if Tag = 200 then
  begin
    Caption := 'Guardar combinacin como...';
    lTexto.Caption := 'Combinacin';
    if FileExists(ExtractFilePath(Application.ExeName) + 'Combinaciones.txt') then
      txtValor.Items.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Combinaciones.txt');
  end;

end;

procedure TformValor.bCancelarClick(Sender: TObject);
begin
  textoSeleccionado := '';
  close;
end;

end.
